unsigned short keydata = 0, special = 0, down = 0;

sbit PS2_Data            at RC0_bit;
sbit PS2_Clock           at RC1_bit;
sbit PS2_Data_Direction  at TRISC0_bit;
sbit PS2_Clock_Direction at TRISC1_bit;

void main() {

  ANSEL  = 0;                                         // Configure AN pins as digital I/O
  ANSELH = 0;
  C1ON_bit = 0;                                       // Disable comparators
  C2ON_bit = 0;

  Ps2_Config();                                       // Init PS/2 Keyboard
  Delay_ms(100);                                      // Wait for keyboard to finish
  trisb=0;
  portb=0;
  do {
    if (Ps2_Key_Read(&keydata, &special, &down)) {
      if (down && (keydata == 16)) {                  // Backspace
         rb2_bit=~rb2_bit;
      }
      else if (down && (keydata == 15)) {             // Enter
         rb1_bit=~rb1_bit;                                                      // for new line transition
      }
      else if (down && (keydata == 1)) {             // F1
         rb0_bit=~rb0_bit;                                                      // for new line transition
      }
      if(down && (keydata == 13))
      portb=0;
      if(down && (keydata == 32)) {
       if(rb0_bit==0 && rb1_bit==0 && rb2_bit==0){
        portb=0;
        rb0_bit=1;
       }
       else if(rb0_bit==1 && rb1_bit==0 && rb2_bit==0){
        portb=0;
            rb1_bit=1;
       }
       else if(rb0_bit==0 && rb1_bit==1 && rb2_bit==0){
        portb=0;
            rb2_bit=1;
       }
       else if(rb0_bit==0 && rb1_bit==0 && rb2_bit==1){
        portb=0;
            rb0_bit=1;
       }
      }
      if(down && (keydata == 33)) {
       if(rb0_bit==0 && rb1_bit==0 && rb2_bit==1){
        portb=0;
        rb1_bit=1;
       }
       else if(rb0_bit==0 && rb1_bit==1 && rb2_bit==0){
                 portb=0;
           rb0_bit=1;
       }
       else if(rb0_bit==1 && rb1_bit==0 && rb2_bit==0){
        portb=0;
            rb2_bit=1;
       }
      }
    }
    Delay_ms(1);                                      // debounce
  } while (1);
}