
_WaitForClockLow:

;ps2_mouse.c,63 :: 		byte WaitForClockLow()  // returns true if the clock went low within the PS2_Mouse_TimeOut
;ps2_mouse.c,66 :: 		TmpW = 0;
	CLRF       R2+0
	CLRF       R2+1
;ps2_mouse.c,67 :: 		do
L_WaitForClockLow0:
;ps2_mouse.c,69 :: 		TmpW++;
	INCF       R2+0, 1
	BTFSC      STATUS+0, 2
	INCF       R2+1, 1
;ps2_mouse.c,70 :: 		} while ((PS2_Clock_Mouse != 0) && (TmpW < PS2_Mouse_TimeOut));
	BTFSS      RC1_bit+0, 1
	GOTO       L__WaitForClockLow109
	MOVF       _PS2_Mouse_TimeOut+1, 0
	SUBWF      R2+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__WaitForClockLow119
	MOVF       _PS2_Mouse_TimeOut+0, 0
	SUBWF      R2+0, 0
L__WaitForClockLow119:
	BTFSC      STATUS+0, 0
	GOTO       L__WaitForClockLow109
	GOTO       L_WaitForClockLow0
L__WaitForClockLow109:
;ps2_mouse.c,71 :: 		return (PS2_Clock_Mouse == 0);
	CLRF       R1+0
	BTFSC      RC1_bit+0, 1
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORLW      0
	MOVLW      1
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
;ps2_mouse.c,72 :: 		}
L_end_WaitForClockLow:
	RETURN
; end of _WaitForClockLow

_WaitForClockHigh:

;ps2_mouse.c,74 :: 		byte WaitForClockHigh()  // returns true if the clock went high within the PS2_Mouse_TimeOut
;ps2_mouse.c,77 :: 		TmpW = 0;
	CLRF       R2+0
	CLRF       R2+1
;ps2_mouse.c,78 :: 		do
L_WaitForClockHigh5:
;ps2_mouse.c,80 :: 		TmpW++;
	INCF       R2+0, 1
	BTFSC      STATUS+0, 2
	INCF       R2+1, 1
;ps2_mouse.c,81 :: 		} while ((PS2_Clock_Mouse != 1) && (TmpW < PS2_Mouse_TimeOut));
	BTFSC      RC1_bit+0, 1
	GOTO       L__WaitForClockHigh110
	MOVF       _PS2_Mouse_TimeOut+1, 0
	SUBWF      R2+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__WaitForClockHigh121
	MOVF       _PS2_Mouse_TimeOut+0, 0
	SUBWF      R2+0, 0
L__WaitForClockHigh121:
	BTFSC      STATUS+0, 0
	GOTO       L__WaitForClockHigh110
	GOTO       L_WaitForClockHigh5
L__WaitForClockHigh110:
;ps2_mouse.c,82 :: 		return (PS2_Clock_Mouse == 1);
	CLRF       R1+0
	BTFSC      RC1_bit+0, 1
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORLW      1
	MOVLW      1
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
;ps2_mouse.c,83 :: 		}
L_end_WaitForClockHigh:
	RETURN
; end of _WaitForClockHigh

_WaitForInitialClockLow:

;ps2_mouse.c,85 :: 		byte WaitForInitialClockLow()  // long timeout
;ps2_mouse.c,88 :: 		TmpW = 0;
	CLRF       R2+0
	CLRF       R2+1
;ps2_mouse.c,89 :: 		do
L_WaitForInitialClockLow10:
;ps2_mouse.c,91 :: 		TmpW++;
	INCF       R2+0, 1
	BTFSC      STATUS+0, 2
	INCF       R2+1, 1
;ps2_mouse.c,92 :: 		} while ((PS2_Clock_Mouse != 0) && (TmpW < PS2_Mouse_TimeOut2));
	BTFSS      RC1_bit+0, 1
	GOTO       L__WaitForInitialClockLow111
	MOVF       _PS2_Mouse_TimeOut2+1, 0
	SUBWF      R2+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__WaitForInitialClockLow123
	MOVF       _PS2_Mouse_TimeOut2+0, 0
	SUBWF      R2+0, 0
L__WaitForInitialClockLow123:
	BTFSC      STATUS+0, 0
	GOTO       L__WaitForInitialClockLow111
	GOTO       L_WaitForInitialClockLow10
L__WaitForInitialClockLow111:
;ps2_mouse.c,93 :: 		return (PS2_Clock_Mouse == 0);
	CLRF       R1+0
	BTFSC      RC1_bit+0, 1
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORLW      0
	MOVLW      1
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
;ps2_mouse.c,94 :: 		}
L_end_WaitForInitialClockLow:
	RETURN
; end of _WaitForInitialClockLow

_PS2_Mouse_Get_Byte:

;ps2_mouse.c,96 :: 		byte PS2_Mouse_Get_Byte()  // Reads one byte from the PS2 Mouse
;ps2_mouse.c,100 :: 		PS2_Mouse_TimeOutError = false;
	CLRF       _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,101 :: 		if (!WaitForInitialClockLow())  // wait for first clockpulse with long timeout
	CALL       _WaitForInitialClockLow+0
	MOVF       R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_Get_Byte15
;ps2_mouse.c,103 :: 		PS2_Mouse_TimeOutError = true;
	MOVLW      1
	MOVWF      _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,104 :: 		return 0;
	CLRF       R0+0
	GOTO       L_end_PS2_Mouse_Get_Byte
;ps2_mouse.c,105 :: 		}
L_PS2_Mouse_Get_Byte15:
;ps2_mouse.c,107 :: 		I = 0;
	CLRF       PS2_Mouse_Get_Byte_I_L0+0
;ps2_mouse.c,108 :: 		Tmp = 0;
	CLRF       PS2_Mouse_Get_Byte_Tmp_L0+0
;ps2_mouse.c,109 :: 		while (I < 11)  // 11 clockpulses expected
L_PS2_Mouse_Get_Byte16:
	MOVLW      11
	SUBWF      PS2_Mouse_Get_Byte_I_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_PS2_Mouse_Get_Byte17
;ps2_mouse.c,111 :: 		if (!WaitForClockLow())  // wait for clock low (start of clockpulse)
	CALL       _WaitForClockLow+0
	MOVF       R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_Get_Byte18
;ps2_mouse.c,113 :: 		PS2_Mouse_TimeOutError = true;
	MOVLW      1
	MOVWF      _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,114 :: 		return 0;
	CLRF       R0+0
	GOTO       L_end_PS2_Mouse_Get_Byte
;ps2_mouse.c,115 :: 		}
L_PS2_Mouse_Get_Byte18:
;ps2_mouse.c,116 :: 		Delay_us(10);
	MOVLW      6
	MOVWF      R13+0
L_PS2_Mouse_Get_Byte19:
	DECFSZ     R13+0, 1
	GOTO       L_PS2_Mouse_Get_Byte19
	NOP
;ps2_mouse.c,117 :: 		if ((I > 0) && (I < 9))
	MOVF       PS2_Mouse_Get_Byte_I_L0+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L_PS2_Mouse_Get_Byte22
	MOVLW      9
	SUBWF      PS2_Mouse_Get_Byte_I_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_PS2_Mouse_Get_Byte22
L__PS2_Mouse_Get_Byte112:
;ps2_mouse.c,119 :: 		Tmp >>= 1;
	RRF        PS2_Mouse_Get_Byte_Tmp_L0+0, 1
	BCF        PS2_Mouse_Get_Byte_Tmp_L0+0, 7
;ps2_mouse.c,120 :: 		Tmp.B7 = PS2_Data_Mouse;
	BTFSC      RC0_bit+0, 0
	GOTO       L__PS2_Mouse_Get_Byte125
	BCF        PS2_Mouse_Get_Byte_Tmp_L0+0, 7
	GOTO       L__PS2_Mouse_Get_Byte126
L__PS2_Mouse_Get_Byte125:
	BSF        PS2_Mouse_Get_Byte_Tmp_L0+0, 7
L__PS2_Mouse_Get_Byte126:
;ps2_mouse.c,121 :: 		}
L_PS2_Mouse_Get_Byte22:
;ps2_mouse.c,122 :: 		if (!WaitForClockHigh())  // wait for clock high (end of clockpulse)
	CALL       _WaitForClockHigh+0
	MOVF       R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_Get_Byte23
;ps2_mouse.c,124 :: 		PS2_Mouse_TimeOutError = true;
	MOVLW      1
	MOVWF      _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,125 :: 		return 0;
	CLRF       R0+0
	GOTO       L_end_PS2_Mouse_Get_Byte
;ps2_mouse.c,126 :: 		}
L_PS2_Mouse_Get_Byte23:
;ps2_mouse.c,127 :: 		I++;
	INCF       PS2_Mouse_Get_Byte_I_L0+0, 1
;ps2_mouse.c,128 :: 		}
	GOTO       L_PS2_Mouse_Get_Byte16
L_PS2_Mouse_Get_Byte17:
;ps2_mouse.c,129 :: 		return Tmp;
	MOVF       PS2_Mouse_Get_Byte_Tmp_L0+0, 0
	MOVWF      R0+0
;ps2_mouse.c,130 :: 		}
L_end_PS2_Mouse_Get_Byte:
	RETURN
; end of _PS2_Mouse_Get_Byte

_PS2_Mouse_SelftestResult:

;ps2_mouse.c,132 :: 		byte PS2_Mouse_SelftestResult()
;ps2_mouse.c,134 :: 		byte Result = false;
	CLRF       PS2_Mouse_SelftestResult_Result_L0+0
;ps2_mouse.c,139 :: 		Cnt = 0;
	CLRF       PS2_Mouse_SelftestResult_Cnt_L0+0
	CLRF       PS2_Mouse_SelftestResult_Cnt_L0+1
;ps2_mouse.c,140 :: 		do
L_PS2_Mouse_SelftestResult24:
;ps2_mouse.c,142 :: 		PS2_Clock_Mouse = 1;
	BSF        RC1_bit+0, 1
;ps2_mouse.c,143 :: 		PS2_Clock_Direction_Mouse = 1;  // release clock (allow Mouse to send)
	BSF        TRISC1_bit+0, 1
;ps2_mouse.c,144 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,146 :: 		Tmp = PS2_Mouse_Get_Byte();
	CALL       _PS2_Mouse_Get_Byte+0
	MOVF       R0+0, 0
	MOVWF      PS2_Mouse_SelftestResult_Tmp_L0+0
;ps2_mouse.c,148 :: 		PS2_Clock_Mouse = 0;
	BCF        RC1_bit+0, 1
;ps2_mouse.c,149 :: 		PS2_Clock_Direction_Mouse = 0;  // block clock (do not allow Mouse to send)
	BCF        TRISC1_bit+0, 1
;ps2_mouse.c,150 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,152 :: 		if (!PS2_Mouse_TimeOutError)      // actual code received
	MOVF       _PS2_Mouse_TimeOutError+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_SelftestResult27
;ps2_mouse.c,154 :: 		if (Tmp == 0xAA)
	MOVF       PS2_Mouse_SelftestResult_Tmp_L0+0, 0
	XORLW      170
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_SelftestResult28
;ps2_mouse.c,155 :: 		Result = true;        // reset completion code (selftest done)
	MOVLW      1
	MOVWF      PS2_Mouse_SelftestResult_Result_L0+0
	GOTO       L_PS2_Mouse_SelftestResult29
L_PS2_Mouse_SelftestResult28:
;ps2_mouse.c,156 :: 		else if (Tmp == 0xFC)
	MOVF       PS2_Mouse_SelftestResult_Tmp_L0+0, 0
	XORLW      252
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_SelftestResult30
;ps2_mouse.c,157 :: 		return false;         // error
	CLRF       R0+0
	GOTO       L_end_PS2_Mouse_SelftestResult
L_PS2_Mouse_SelftestResult30:
L_PS2_Mouse_SelftestResult29:
;ps2_mouse.c,158 :: 		}
L_PS2_Mouse_SelftestResult27:
;ps2_mouse.c,160 :: 		Cnt++;
	INCF       PS2_Mouse_SelftestResult_Cnt_L0+0, 1
	BTFSC      STATUS+0, 2
	INCF       PS2_Mouse_SelftestResult_Cnt_L0+1, 1
;ps2_mouse.c,161 :: 		} while ((Result != true) && (Cnt < 66)); // 66 times 30 msecs is approx 2 secs
	MOVF       PS2_Mouse_SelftestResult_Result_L0+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L__PS2_Mouse_SelftestResult113
	MOVLW      0
	SUBWF      PS2_Mouse_SelftestResult_Cnt_L0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__PS2_Mouse_SelftestResult128
	MOVLW      66
	SUBWF      PS2_Mouse_SelftestResult_Cnt_L0+0, 0
L__PS2_Mouse_SelftestResult128:
	BTFSC      STATUS+0, 0
	GOTO       L__PS2_Mouse_SelftestResult113
	GOTO       L_PS2_Mouse_SelftestResult24
L__PS2_Mouse_SelftestResult113:
;ps2_mouse.c,163 :: 		do                               // purge any extra bytes sent
L_PS2_Mouse_SelftestResult33:
;ps2_mouse.c,165 :: 		PS2_Clock_Mouse = 1;
	BSF        RC1_bit+0, 1
;ps2_mouse.c,166 :: 		PS2_Clock_Direction_Mouse = 1;  // release clock (allow Mouse to send)
	BSF        TRISC1_bit+0, 1
;ps2_mouse.c,167 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,168 :: 		Tmp = PS2_Mouse_Get_Byte();
	CALL       _PS2_Mouse_Get_Byte+0
	MOVF       R0+0, 0
	MOVWF      PS2_Mouse_SelftestResult_Tmp_L0+0
;ps2_mouse.c,169 :: 		} while (!PS2_Mouse_TimeOutError);
	MOVF       _PS2_Mouse_TimeOutError+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_PS2_Mouse_SelftestResult33
;ps2_mouse.c,171 :: 		PS2_Clock_Mouse = 0;
	BCF        RC1_bit+0, 1
;ps2_mouse.c,172 :: 		PS2_Clock_Direction_Mouse = 0;  // block clock (do not allow Mouse to send)
	BCF        TRISC1_bit+0, 1
;ps2_mouse.c,173 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,174 :: 		return Result;
	MOVF       PS2_Mouse_SelftestResult_Result_L0+0, 0
	MOVWF      R0+0
;ps2_mouse.c,175 :: 		}
L_end_PS2_Mouse_SelftestResult:
	RETURN
; end of _PS2_Mouse_SelftestResult

_PS2_Mouse_Enable_ScrollWheel:

;ps2_mouse.c,177 :: 		byte PS2_Mouse_Enable_ScrollWheel()
;ps2_mouse.c,182 :: 		Cmd[0] = 0xF3;     // Set Sample rate command
	MOVLW      243
	MOVWF      PS2_Mouse_Enable_ScrollWheel_Cmd_L0+0
;ps2_mouse.c,183 :: 		Cmd[1] = 200;      // 200
	MOVLW      200
	MOVWF      PS2_Mouse_Enable_ScrollWheel_Cmd_L0+1
;ps2_mouse.c,184 :: 		Cmd[2] = 0xF3;
	MOVLW      243
	MOVWF      PS2_Mouse_Enable_ScrollWheel_Cmd_L0+2
;ps2_mouse.c,185 :: 		Cmd[3] = 100;      // 100
	MOVLW      100
	MOVWF      PS2_Mouse_Enable_ScrollWheel_Cmd_L0+3
;ps2_mouse.c,186 :: 		Cmd[4] = 0xF3;
	MOVLW      243
	MOVWF      PS2_Mouse_Enable_ScrollWheel_Cmd_L0+4
;ps2_mouse.c,187 :: 		Cmd[5] = 80;       // 80
	MOVLW      80
	MOVWF      PS2_Mouse_Enable_ScrollWheel_Cmd_L0+5
;ps2_mouse.c,188 :: 		Cmd[6] = 0xF2;     // get ID byte
	MOVLW      242
	MOVWF      PS2_Mouse_Enable_ScrollWheel_Cmd_L0+6
;ps2_mouse.c,189 :: 		PS2_Mouse_Write(Cmd, 7);
	MOVLW      PS2_Mouse_Enable_ScrollWheel_Cmd_L0+0
	MOVWF      FARG_PS2_Mouse_Write_Values+0
	MOVLW      7
	MOVWF      FARG_PS2_Mouse_Write_Count+0
	CALL       _PS2_Mouse_Write+0
;ps2_mouse.c,191 :: 		PS2_Clock_Mouse = 1;
	BSF        RC1_bit+0, 1
;ps2_mouse.c,192 :: 		PS2_Clock_Direction_Mouse = 1;
	BSF        TRISC1_bit+0, 1
;ps2_mouse.c,193 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,195 :: 		Tmp = PS2_Mouse_Get_Byte();
	CALL       _PS2_Mouse_Get_Byte+0
	MOVF       R0+0, 0
	MOVWF      PS2_Mouse_Enable_ScrollWheel_Tmp_L0+0
;ps2_mouse.c,197 :: 		PS2_Clock_Mouse = 0;
	BCF        RC1_bit+0, 1
;ps2_mouse.c,198 :: 		PS2_Clock_Direction_Mouse = 0;
	BCF        TRISC1_bit+0, 1
;ps2_mouse.c,199 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,201 :: 		return ((!PS2_Mouse_TimeOutError) && (Tmp == 3));
	MOVF       _PS2_Mouse_TimeOutError+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_Enable_ScrollWheel37
	MOVF       PS2_Mouse_Enable_ScrollWheel_Tmp_L0+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_Enable_ScrollWheel37
	MOVLW      1
	MOVWF      R0+0
	GOTO       L_PS2_Mouse_Enable_ScrollWheel36
L_PS2_Mouse_Enable_ScrollWheel37:
	CLRF       R0+0
L_PS2_Mouse_Enable_ScrollWheel36:
;ps2_mouse.c,202 :: 		}
L_end_PS2_Mouse_Enable_ScrollWheel:
	RETURN
; end of _PS2_Mouse_Enable_ScrollWheel

_PS2_Mouse_ScrollWheel_Present:

;ps2_mouse.c,204 :: 		byte PS2_Mouse_ScrollWheel_Present()
;ps2_mouse.c,206 :: 		return PS2_Mouse_ScrollWheel;
	MOVF       _PS2_Mouse_ScrollWheel+0, 0
	MOVWF      R0+0
;ps2_mouse.c,207 :: 		}
L_end_PS2_Mouse_ScrollWheel_Present:
	RETURN
; end of _PS2_Mouse_ScrollWheel_Present

_PS2_Mouse_Reset:

;ps2_mouse.c,209 :: 		byte PS2_Mouse_Reset()
;ps2_mouse.c,214 :: 		PS2_Mouse_TimeOutError = false;
	CLRF       _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,215 :: 		PS2_Mouse_ScrollWheel  = false;
	CLRF       _PS2_Mouse_ScrollWheel+0
;ps2_mouse.c,216 :: 		Result = false;
	CLRF       PS2_Mouse_Reset_Result_L0+0
;ps2_mouse.c,218 :: 		Arr = 0xFF;                          // reset command
	MOVLW      255
	MOVWF      PS2_Mouse_Reset_Arr_L0+0
;ps2_mouse.c,219 :: 		PS2_Mouse_Write(&Arr, 1);
	MOVLW      PS2_Mouse_Reset_Arr_L0+0
	MOVWF      FARG_PS2_Mouse_Write_Values+0
	MOVLW      1
	MOVWF      FARG_PS2_Mouse_Write_Count+0
	CALL       _PS2_Mouse_Write+0
;ps2_mouse.c,221 :: 		Result = PS2_Mouse_SelftestResult();
	CALL       _PS2_Mouse_SelftestResult+0
	MOVF       R0+0, 0
	MOVWF      PS2_Mouse_Reset_Result_L0+0
;ps2_mouse.c,223 :: 		PS2_Mouse_ScrollWheel = PS2_Mouse_Enable_ScrollWheel();
	CALL       _PS2_Mouse_Enable_ScrollWheel+0
	MOVF       R0+0, 0
	MOVWF      _PS2_Mouse_ScrollWheel+0
;ps2_mouse.c,225 :: 		Arr = 0xF4;                         // Enable Data Reporting
	MOVLW      244
	MOVWF      PS2_Mouse_Reset_Arr_L0+0
;ps2_mouse.c,226 :: 		PS2_Mouse_Write(&Arr, 1);
	MOVLW      PS2_Mouse_Reset_Arr_L0+0
	MOVWF      FARG_PS2_Mouse_Write_Values+0
	MOVLW      1
	MOVWF      FARG_PS2_Mouse_Write_Count+0
	CALL       _PS2_Mouse_Write+0
;ps2_mouse.c,228 :: 		PS2_Clock_Mouse = 0;                // force clock low (prevent mouse from sending data)
	BCF        RC1_bit+0, 1
;ps2_mouse.c,229 :: 		PS2_Clock_Direction_Mouse = 0;
	BCF        TRISC1_bit+0, 1
;ps2_mouse.c,230 :: 		Delay_us(2);                        // prevent read after write problem
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,231 :: 		return Result;
	MOVF       PS2_Mouse_Reset_Result_L0+0, 0
	MOVWF      R0+0
;ps2_mouse.c,232 :: 		}
L_end_PS2_Mouse_Reset:
	RETURN
; end of _PS2_Mouse_Reset

_PS2_Mouse_Init:

;ps2_mouse.c,234 :: 		byte PS2_Mouse_Init()  // Initializes the Mouse Ps2 routines
;ps2_mouse.c,236 :: 		PS2_Mouse_TimeOutError = false;
	CLRF       _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,237 :: 		PS2_Mouse_ScrollWheel = false;
	CLRF       _PS2_Mouse_ScrollWheel+0
;ps2_mouse.c,239 :: 		PS2_Mouse_TimeOut  = (unsigned int)(20 * Clock_MHz());  // gives approx 1 ms of timeout
	MOVLW      160
	MOVWF      _PS2_Mouse_TimeOut+0
	MOVLW      0
	MOVWF      _PS2_Mouse_TimeOut+1
;ps2_mouse.c,240 :: 		PS2_Mouse_TimeOut2 = 30 * PS2_Mouse_TimeOut;            // approx 30 ms
	MOVLW      192
	MOVWF      _PS2_Mouse_TimeOut2+0
	MOVLW      18
	MOVWF      _PS2_Mouse_TimeOut2+1
;ps2_mouse.c,242 :: 		PS2_Clock_Mouse = 0;            // force clock low
	BCF        RC1_bit+0, 1
;ps2_mouse.c,243 :: 		PS2_Clock_Direction_Mouse = 0;
	BCF        TRISC1_bit+0, 1
;ps2_mouse.c,244 :: 		Delay_us(2);                    // prevent read after write problem
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,246 :: 		PS2_Data_Mouse = 1;
	BSF        RC0_bit+0, 0
;ps2_mouse.c,247 :: 		PS2_Data_Direction_Mouse = 1;
	BSF        TRISC0_bit+0, 0
;ps2_mouse.c,248 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,250 :: 		PS2_Mouse_SelftestResult();
	CALL       _PS2_Mouse_SelftestResult+0
;ps2_mouse.c,251 :: 		return PS2_Mouse_Reset();       // give extra reset
	CALL       _PS2_Mouse_Reset+0
;ps2_mouse.c,252 :: 		}
L_end_PS2_Mouse_Init:
	RETURN
; end of _PS2_Mouse_Init

_PS2_Mouse_ReadData:

;ps2_mouse.c,254 :: 		byte PS2_Mouse_ReadData(TMouseData *MouseData)  // Reads 3 or 4 bytes from the Ps2 Mouse into "MouseData"
;ps2_mouse.c,257 :: 		byte TmpCodes[4] = {0,0,0,0};
	CLRF       PS2_Mouse_ReadData_TmpCodes_L0+0
	CLRF       PS2_Mouse_ReadData_TmpCodes_L0+1
	CLRF       PS2_Mouse_ReadData_TmpCodes_L0+2
	CLRF       PS2_Mouse_ReadData_TmpCodes_L0+3
;ps2_mouse.c,260 :: 		if (PS2_Mouse_ScrollWheel)
	MOVF       _PS2_Mouse_ScrollWheel+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_PS2_Mouse_ReadData38
;ps2_mouse.c,261 :: 		MaxCount = 4;
	MOVLW      4
	MOVWF      PS2_Mouse_ReadData_MaxCount_L0+0
	GOTO       L_PS2_Mouse_ReadData39
L_PS2_Mouse_ReadData38:
;ps2_mouse.c,263 :: 		MaxCount = 3;
	MOVLW      3
	MOVWF      PS2_Mouse_ReadData_MaxCount_L0+0
L_PS2_Mouse_ReadData39:
;ps2_mouse.c,265 :: 		PS2_Mouse_TimeOutError = false;
	CLRF       _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,267 :: 		PS2_Clock_Mouse = 1;
	BSF        RC1_bit+0, 1
;ps2_mouse.c,268 :: 		PS2_Clock_Direction_Mouse = 1;  // release clock (allow Mouse to send)
	BSF        TRISC1_bit+0, 1
;ps2_mouse.c,269 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,283 :: 		Index = 0;
	CLRF       PS2_Mouse_ReadData_Index_L0+0
;ps2_mouse.c,284 :: 		do  // get bytes until all bytes read
L_PS2_Mouse_ReadData40:
;ps2_mouse.c,286 :: 		Tmp = PS2_Mouse_Get_Byte();
	CALL       _PS2_Mouse_Get_Byte+0
	MOVF       R0+0, 0
	MOVWF      PS2_Mouse_ReadData_Tmp_L0+0
;ps2_mouse.c,287 :: 		if (PS2_Mouse_TimeOutError)
	MOVF       _PS2_Mouse_TimeOutError+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_PS2_Mouse_ReadData43
;ps2_mouse.c,289 :: 		PS2_Clock_Mouse = 0;
	BCF        RC1_bit+0, 1
;ps2_mouse.c,290 :: 		PS2_Clock_Direction_Mouse = 0;  // block clock
	BCF        TRISC1_bit+0, 1
;ps2_mouse.c,291 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,292 :: 		return 0;                       // Read Error
	CLRF       R0+0
	GOTO       L_end_PS2_Mouse_ReadData
;ps2_mouse.c,293 :: 		}
L_PS2_Mouse_ReadData43:
;ps2_mouse.c,294 :: 		TmpCodes[Index] = Tmp;
	MOVF       PS2_Mouse_ReadData_Index_L0+0, 0
	ADDLW      PS2_Mouse_ReadData_TmpCodes_L0+0
	MOVWF      FSR
	MOVF       PS2_Mouse_ReadData_Tmp_L0+0, 0
	MOVWF      INDF+0
;ps2_mouse.c,295 :: 		Index++;
	INCF       PS2_Mouse_ReadData_Index_L0+0, 1
;ps2_mouse.c,297 :: 		while (Index != MaxCount);
	MOVF       PS2_Mouse_ReadData_Index_L0+0, 0
	XORWF      PS2_Mouse_ReadData_MaxCount_L0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_ReadData40
;ps2_mouse.c,299 :: 		PS2_Clock_Mouse = 0;
	BCF        RC1_bit+0, 1
;ps2_mouse.c,300 :: 		PS2_Clock_Direction_Mouse = 0;     // block clock (prevent Mouse to send)
	BCF        TRISC1_bit+0, 1
;ps2_mouse.c,301 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,303 :: 		MouseData->Keys = TmpCodes[0] & 7;
	MOVLW      7
	ANDWF      PS2_Mouse_ReadData_TmpCodes_L0+0, 0
	MOVWF      R0+0
	MOVF       FARG_PS2_Mouse_ReadData_MouseData+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;ps2_mouse.c,305 :: 		if (TmpCodes[0].B4 == 1)           // X "sign" bit
	BTFSS      PS2_Mouse_ReadData_TmpCodes_L0+0, 4
	GOTO       L_PS2_Mouse_ReadData44
;ps2_mouse.c,306 :: 		MouseData->DeltaX = TmpCodes[1] | 0xFF00;
	INCF       FARG_PS2_Mouse_ReadData_MouseData+0, 0
	MOVWF      FSR
	MOVLW      0
	IORWF      PS2_Mouse_ReadData_TmpCodes_L0+1, 0
	MOVWF      R0+0
	MOVLW      0
	IORLW      255
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      INDF+0
	MOVF       R0+1, 0
	INCF       FSR, 1
	MOVWF      INDF+0
	GOTO       L_PS2_Mouse_ReadData45
L_PS2_Mouse_ReadData44:
;ps2_mouse.c,308 :: 		MouseData->DeltaX = TmpCodes[1];
	INCF       FARG_PS2_Mouse_ReadData_MouseData+0, 0
	MOVWF      FSR
	MOVF       PS2_Mouse_ReadData_TmpCodes_L0+1, 0
	MOVWF      INDF+0
	INCF       FSR, 1
	CLRF       INDF+0
L_PS2_Mouse_ReadData45:
;ps2_mouse.c,310 :: 		if (TmpCodes[0].B5 == 1)          // Y "sign" bit
	BTFSS      PS2_Mouse_ReadData_TmpCodes_L0+0, 5
	GOTO       L_PS2_Mouse_ReadData46
;ps2_mouse.c,311 :: 		MouseData->DeltaY = TmpCodes[2] | 0xFF00;
	MOVLW      3
	ADDWF      FARG_PS2_Mouse_ReadData_MouseData+0, 0
	MOVWF      FSR
	MOVLW      0
	IORWF      PS2_Mouse_ReadData_TmpCodes_L0+2, 0
	MOVWF      R0+0
	MOVLW      0
	IORLW      255
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      INDF+0
	MOVF       R0+1, 0
	INCF       FSR, 1
	MOVWF      INDF+0
	GOTO       L_PS2_Mouse_ReadData47
L_PS2_Mouse_ReadData46:
;ps2_mouse.c,313 :: 		MouseData->DeltaY = TmpCodes[2];
	MOVLW      3
	ADDWF      FARG_PS2_Mouse_ReadData_MouseData+0, 0
	MOVWF      FSR
	MOVF       PS2_Mouse_ReadData_TmpCodes_L0+2, 0
	MOVWF      INDF+0
	INCF       FSR, 1
	CLRF       INDF+0
L_PS2_Mouse_ReadData47:
;ps2_mouse.c,315 :: 		if (TmpCodes[3].B7 == 1)          // scrollwheel sign bit
	BTFSS      PS2_Mouse_ReadData_TmpCodes_L0+3, 7
	GOTO       L_PS2_Mouse_ReadData48
;ps2_mouse.c,316 :: 		MouseData->DeltaZ = TmpCodes[3] | 0xFF00;
	MOVLW      5
	ADDWF      FARG_PS2_Mouse_ReadData_MouseData+0, 0
	MOVWF      FSR
	MOVLW      0
	IORWF      PS2_Mouse_ReadData_TmpCodes_L0+3, 0
	MOVWF      R0+0
	MOVLW      0
	IORLW      255
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      INDF+0
	MOVF       R0+1, 0
	INCF       FSR, 1
	MOVWF      INDF+0
	GOTO       L_PS2_Mouse_ReadData49
L_PS2_Mouse_ReadData48:
;ps2_mouse.c,318 :: 		MouseData->DeltaZ = TmpCodes[3];
	MOVLW      5
	ADDWF      FARG_PS2_Mouse_ReadData_MouseData+0, 0
	MOVWF      FSR
	MOVF       PS2_Mouse_ReadData_TmpCodes_L0+3, 0
	MOVWF      INDF+0
	INCF       FSR, 1
	CLRF       INDF+0
L_PS2_Mouse_ReadData49:
;ps2_mouse.c,320 :: 		return true;
	MOVLW      1
	MOVWF      R0+0
;ps2_mouse.c,321 :: 		}
L_end_PS2_Mouse_ReadData:
	RETURN
; end of _PS2_Mouse_ReadData

_WaitForClockHighThenLow:

;ps2_mouse.c,323 :: 		byte WaitForClockHighThenLow()
;ps2_mouse.c,326 :: 		TmpW = 0;
	CLRF       R2+0
	CLRF       R2+1
;ps2_mouse.c,327 :: 		do
L_WaitForClockHighThenLow50:
;ps2_mouse.c,329 :: 		TmpW++;
	INCF       R2+0, 1
	BTFSC      STATUS+0, 2
	INCF       R2+1, 1
;ps2_mouse.c,331 :: 		while ((PS2_Clock_Mouse != 1) && (TmpW < PS2_Mouse_TimeOut));
	BTFSC      RC1_bit+0, 1
	GOTO       L__WaitForClockHighThenLow115
	MOVF       _PS2_Mouse_TimeOut+1, 0
	SUBWF      R2+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__WaitForClockHighThenLow135
	MOVF       _PS2_Mouse_TimeOut+0, 0
	SUBWF      R2+0, 0
L__WaitForClockHighThenLow135:
	BTFSC      STATUS+0, 0
	GOTO       L__WaitForClockHighThenLow115
	GOTO       L_WaitForClockHighThenLow50
L__WaitForClockHighThenLow115:
;ps2_mouse.c,333 :: 		if (PS2_Clock_Mouse != 1)
	BTFSC      RC1_bit+0, 1
	GOTO       L_WaitForClockHighThenLow55
;ps2_mouse.c,334 :: 		return false;
	CLRF       R0+0
	GOTO       L_end_WaitForClockHighThenLow
L_WaitForClockHighThenLow55:
;ps2_mouse.c,336 :: 		TmpW = 0;
	CLRF       R2+0
	CLRF       R2+1
;ps2_mouse.c,337 :: 		do
L_WaitForClockHighThenLow56:
;ps2_mouse.c,339 :: 		TmpW++;
	INCF       R2+0, 1
	BTFSC      STATUS+0, 2
	INCF       R2+1, 1
;ps2_mouse.c,341 :: 		while ((PS2_Clock_Mouse != 0) && (TmpW < PS2_Mouse_TimeOut));
	BTFSS      RC1_bit+0, 1
	GOTO       L__WaitForClockHighThenLow114
	MOVF       _PS2_Mouse_TimeOut+1, 0
	SUBWF      R2+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__WaitForClockHighThenLow136
	MOVF       _PS2_Mouse_TimeOut+0, 0
	SUBWF      R2+0, 0
L__WaitForClockHighThenLow136:
	BTFSC      STATUS+0, 0
	GOTO       L__WaitForClockHighThenLow114
	GOTO       L_WaitForClockHighThenLow56
L__WaitForClockHighThenLow114:
;ps2_mouse.c,343 :: 		return (PS2_Clock_Mouse == 0);
	CLRF       R1+0
	BTFSC      RC1_bit+0, 1
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORLW      0
	MOVLW      1
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
;ps2_mouse.c,344 :: 		}
L_end_WaitForClockHighThenLow:
	RETURN
; end of _WaitForClockHighThenLow

_WaitForDataLowThenHigh:

;ps2_mouse.c,346 :: 		byte WaitForDataLowThenHigh()
;ps2_mouse.c,349 :: 		TmpW = 0;
	CLRF       R2+0
	CLRF       R2+1
;ps2_mouse.c,350 :: 		do
L_WaitForDataLowThenHigh61:
;ps2_mouse.c,352 :: 		TmpW++;
	INCF       R2+0, 1
	BTFSC      STATUS+0, 2
	INCF       R2+1, 1
;ps2_mouse.c,354 :: 		while ((PS2_Data_Mouse != 0) && (TmpW < PS2_Mouse_TimeOut));
	BTFSS      RC0_bit+0, 0
	GOTO       L__WaitForDataLowThenHigh117
	MOVF       _PS2_Mouse_TimeOut+1, 0
	SUBWF      R2+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__WaitForDataLowThenHigh138
	MOVF       _PS2_Mouse_TimeOut+0, 0
	SUBWF      R2+0, 0
L__WaitForDataLowThenHigh138:
	BTFSC      STATUS+0, 0
	GOTO       L__WaitForDataLowThenHigh117
	GOTO       L_WaitForDataLowThenHigh61
L__WaitForDataLowThenHigh117:
;ps2_mouse.c,356 :: 		if (PS2_Data_Mouse != 0)
	BTFSS      RC0_bit+0, 0
	GOTO       L_WaitForDataLowThenHigh66
;ps2_mouse.c,357 :: 		return false;
	CLRF       R0+0
	GOTO       L_end_WaitForDataLowThenHigh
L_WaitForDataLowThenHigh66:
;ps2_mouse.c,359 :: 		TmpW = 0;
	CLRF       R2+0
	CLRF       R2+1
;ps2_mouse.c,360 :: 		do
L_WaitForDataLowThenHigh67:
;ps2_mouse.c,362 :: 		TmpW++;
	INCF       R2+0, 1
	BTFSC      STATUS+0, 2
	INCF       R2+1, 1
;ps2_mouse.c,364 :: 		while ((PS2_Data_Mouse != 1) && (TmpW < PS2_Mouse_TimeOut));
	BTFSC      RC0_bit+0, 0
	GOTO       L__WaitForDataLowThenHigh116
	MOVF       _PS2_Mouse_TimeOut+1, 0
	SUBWF      R2+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__WaitForDataLowThenHigh139
	MOVF       _PS2_Mouse_TimeOut+0, 0
	SUBWF      R2+0, 0
L__WaitForDataLowThenHigh139:
	BTFSC      STATUS+0, 0
	GOTO       L__WaitForDataLowThenHigh116
	GOTO       L_WaitForDataLowThenHigh67
L__WaitForDataLowThenHigh116:
;ps2_mouse.c,366 :: 		return (PS2_Data_Mouse == 1);
	CLRF       R1+0
	BTFSC      RC0_bit+0, 0
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORLW      1
	MOVLW      1
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
;ps2_mouse.c,367 :: 		}
L_end_WaitForDataLowThenHigh:
	RETURN
; end of _WaitForDataLowThenHigh

_PS2_Mouse_Write_Byte:

;ps2_mouse.c,370 :: 		void PS2_Mouse_Write_Byte(byte Value)  // writes 1 byte to the PS2 Mouse (command or data)
;ps2_mouse.c,373 :: 		PS2_Mouse_TimeOutError = false;
	CLRF       _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,376 :: 		Parity = 0;
	CLRF       PS2_Mouse_Write_Byte_Parity_L0+0
;ps2_mouse.c,377 :: 		for (I = 1; I; I<<=1)
	MOVLW      1
	MOVWF      PS2_Mouse_Write_Byte_I_L0+0
L_PS2_Mouse_Write_Byte72:
	MOVF       PS2_Mouse_Write_Byte_I_L0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_PS2_Mouse_Write_Byte73
;ps2_mouse.c,378 :: 		if (!(Value & I))
	MOVF       PS2_Mouse_Write_Byte_I_L0+0, 0
	ANDWF      FARG_PS2_Mouse_Write_Byte_Value+0, 0
	MOVWF      R0+0
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_Write_Byte75
;ps2_mouse.c,379 :: 		Parity++;
	INCF       PS2_Mouse_Write_Byte_Parity_L0+0, 1
L_PS2_Mouse_Write_Byte75:
;ps2_mouse.c,377 :: 		for (I = 1; I; I<<=1)
	RLF        PS2_Mouse_Write_Byte_I_L0+0, 1
	BCF        PS2_Mouse_Write_Byte_I_L0+0, 0
;ps2_mouse.c,379 :: 		Parity++;
	GOTO       L_PS2_Mouse_Write_Byte72
L_PS2_Mouse_Write_Byte73:
;ps2_mouse.c,380 :: 		if (Parity.B0 == 1) // odd
	BTFSS      PS2_Mouse_Write_Byte_Parity_L0+0, 0
	GOTO       L_PS2_Mouse_Write_Byte76
;ps2_mouse.c,381 :: 		Parity = 0;
	CLRF       PS2_Mouse_Write_Byte_Parity_L0+0
	GOTO       L_PS2_Mouse_Write_Byte77
L_PS2_Mouse_Write_Byte76:
;ps2_mouse.c,383 :: 		Parity = 1;
	MOVLW      1
	MOVWF      PS2_Mouse_Write_Byte_Parity_L0+0
L_PS2_Mouse_Write_Byte77:
;ps2_mouse.c,386 :: 		PS2_Clock_Mouse = 0;
	BCF        RC1_bit+0, 1
;ps2_mouse.c,387 :: 		PS2_Clock_Direction_Mouse = 0;  // block clock
	BCF        TRISC1_bit+0, 1
;ps2_mouse.c,388 :: 		Delay_us(200);
	MOVLW      133
	MOVWF      R13+0
L_PS2_Mouse_Write_Byte78:
	DECFSZ     R13+0, 1
	GOTO       L_PS2_Mouse_Write_Byte78
;ps2_mouse.c,389 :: 		PS2_Data_Mouse = 0;
	BCF        RC0_bit+0, 0
;ps2_mouse.c,390 :: 		PS2_Data_Direction_Mouse = 0;   // Make data line zero
	BCF        TRISC0_bit+0, 0
;ps2_mouse.c,391 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,392 :: 		PS2_Clock_Direction_Mouse = 1;
	BSF        TRISC1_bit+0, 1
;ps2_mouse.c,393 :: 		PS2_Clock_Mouse = 1;            // release clock line
	BSF        RC1_bit+0, 1
;ps2_mouse.c,394 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,396 :: 		if (!WaitForInitialClockLow())
	CALL       _WaitForInitialClockLow+0
	MOVF       R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_Write_Byte79
;ps2_mouse.c,398 :: 		PS2_Mouse_TimeOutError = true;
	MOVLW      1
	MOVWF      _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,399 :: 		goto ExitWriteByte;
	GOTO       ___PS2_Mouse_Write_Byte_ExitWriteByte
;ps2_mouse.c,400 :: 		}
L_PS2_Mouse_Write_Byte79:
;ps2_mouse.c,403 :: 		for (I = 0; I <= 8; I++)
	CLRF       PS2_Mouse_Write_Byte_I_L0+0
L_PS2_Mouse_Write_Byte80:
	MOVF       PS2_Mouse_Write_Byte_I_L0+0, 0
	SUBLW      8
	BTFSS      STATUS+0, 0
	GOTO       L_PS2_Mouse_Write_Byte81
;ps2_mouse.c,405 :: 		if (I < 8)
	MOVLW      8
	SUBWF      PS2_Mouse_Write_Byte_I_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_PS2_Mouse_Write_Byte83
;ps2_mouse.c,407 :: 		PS2_Data_Mouse = Value.B0;   // send LSB bit
	BTFSC      FARG_PS2_Mouse_Write_Byte_Value+0, 0
	GOTO       L__PS2_Mouse_Write_Byte141
	BCF        RC0_bit+0, 0
	GOTO       L__PS2_Mouse_Write_Byte142
L__PS2_Mouse_Write_Byte141:
	BSF        RC0_bit+0, 0
L__PS2_Mouse_Write_Byte142:
;ps2_mouse.c,408 :: 		Value >>= 1;                 // get next bit
	RRF        FARG_PS2_Mouse_Write_Byte_Value+0, 1
	BCF        FARG_PS2_Mouse_Write_Byte_Value+0, 7
;ps2_mouse.c,409 :: 		}
	GOTO       L_PS2_Mouse_Write_Byte84
L_PS2_Mouse_Write_Byte83:
;ps2_mouse.c,411 :: 		PS2_Data_Mouse = Parity;     // send parity
	BTFSC      PS2_Mouse_Write_Byte_Parity_L0+0, 0
	GOTO       L__PS2_Mouse_Write_Byte143
	BCF        RC0_bit+0, 0
	GOTO       L__PS2_Mouse_Write_Byte144
L__PS2_Mouse_Write_Byte143:
	BSF        RC0_bit+0, 0
L__PS2_Mouse_Write_Byte144:
L_PS2_Mouse_Write_Byte84:
;ps2_mouse.c,413 :: 		if (!WaitForClockHighThenLow())
	CALL       _WaitForClockHighThenLow+0
	MOVF       R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_Write_Byte85
;ps2_mouse.c,415 :: 		PS2_Mouse_TimeOutError = true;
	MOVLW      1
	MOVWF      _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,416 :: 		goto ExitWriteByte;
	GOTO       ___PS2_Mouse_Write_Byte_ExitWriteByte
;ps2_mouse.c,417 :: 		}
L_PS2_Mouse_Write_Byte85:
;ps2_mouse.c,403 :: 		for (I = 0; I <= 8; I++)
	INCF       PS2_Mouse_Write_Byte_I_L0+0, 1
;ps2_mouse.c,418 :: 		}
	GOTO       L_PS2_Mouse_Write_Byte80
L_PS2_Mouse_Write_Byte81:
;ps2_mouse.c,420 :: 		PS2_Data_Mouse = 1;
	BSF        RC0_bit+0, 0
;ps2_mouse.c,421 :: 		PS2_Data_Direction_Mouse = 1;   // release dataline
	BSF        TRISC0_bit+0, 0
;ps2_mouse.c,423 :: 		if (!WaitForClockHighThenLow())
	CALL       _WaitForClockHighThenLow+0
	MOVF       R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_Write_Byte86
;ps2_mouse.c,425 :: 		PS2_Mouse_TimeOutError = true;
	MOVLW      1
	MOVWF      _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,426 :: 		goto ExitWriteByte;
	GOTO       ___PS2_Mouse_Write_Byte_ExitWriteByte
;ps2_mouse.c,427 :: 		}
L_PS2_Mouse_Write_Byte86:
;ps2_mouse.c,429 :: 		if (!WaitForDataLowThenHigh())  // Check acknowledge (data line)
	CALL       _WaitForDataLowThenHigh+0
	MOVF       R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_PS2_Mouse_Write_Byte87
;ps2_mouse.c,431 :: 		PS2_Mouse_TimeOutError = true;
	MOVLW      1
	MOVWF      _PS2_Mouse_TimeOutError+0
;ps2_mouse.c,432 :: 		goto ExitWriteByte;
	GOTO       ___PS2_Mouse_Write_Byte_ExitWriteByte
;ps2_mouse.c,433 :: 		}
L_PS2_Mouse_Write_Byte87:
;ps2_mouse.c,435 :: 		ExitWriteByte:
___PS2_Mouse_Write_Byte_ExitWriteByte:
;ps2_mouse.c,437 :: 		PS2_Data_Direction_Mouse  = 1;
	BSF        TRISC0_bit+0, 0
;ps2_mouse.c,438 :: 		PS2_Data_Mouse  = 1;
	BSF        RC0_bit+0, 0
;ps2_mouse.c,439 :: 		PS2_Clock_Direction_Mouse = 1;
	BSF        TRISC1_bit+0, 1
;ps2_mouse.c,440 :: 		PS2_Clock_Mouse = 1;
	BSF        RC1_bit+0, 1
;ps2_mouse.c,441 :: 		}
L_end_PS2_Mouse_Write_Byte:
	RETURN
; end of _PS2_Mouse_Write_Byte

_PS2_Mouse_Write:

;ps2_mouse.c,443 :: 		void PS2_Mouse_Write(byte *Values, byte Count)  // Writes "Count" bytes out of "Values" to the PS2 Mouse.
;ps2_mouse.c,446 :: 		Index = 0;
	CLRF       PS2_Mouse_Write_Index_L0+0
;ps2_mouse.c,447 :: 		while (Count > 0)
L_PS2_Mouse_Write88:
	MOVF       FARG_PS2_Mouse_Write_Count+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L_PS2_Mouse_Write89
;ps2_mouse.c,449 :: 		PS2_Mouse_Write_Byte(Values[Index]);  // send byte to the Mouse
	MOVF       PS2_Mouse_Write_Index_L0+0, 0
	ADDWF      FARG_PS2_Mouse_Write_Values+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_PS2_Mouse_Write_Byte_Value+0
	CALL       _PS2_Mouse_Write_Byte+0
;ps2_mouse.c,450 :: 		if (PS2_Mouse_TimeOutError)
	MOVF       _PS2_Mouse_TimeOutError+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_PS2_Mouse_Write90
;ps2_mouse.c,451 :: 		break;
	GOTO       L_PS2_Mouse_Write89
L_PS2_Mouse_Write90:
;ps2_mouse.c,453 :: 		Reply = PS2_Mouse_Get_Byte();         // get the reply (0xFA is Ok)
	CALL       _PS2_Mouse_Get_Byte+0
;ps2_mouse.c,454 :: 		if (PS2_Mouse_TimeOutError)
	MOVF       _PS2_Mouse_TimeOutError+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_PS2_Mouse_Write91
;ps2_mouse.c,455 :: 		break;
	GOTO       L_PS2_Mouse_Write89
L_PS2_Mouse_Write91:
;ps2_mouse.c,457 :: 		Index++;
	INCF       PS2_Mouse_Write_Index_L0+0, 1
;ps2_mouse.c,458 :: 		Count--;
	DECF       FARG_PS2_Mouse_Write_Count+0, 1
;ps2_mouse.c,459 :: 		}
	GOTO       L_PS2_Mouse_Write88
L_PS2_Mouse_Write89:
;ps2_mouse.c,461 :: 		PS2_Clock_Mouse = 0;
	BCF        RC1_bit+0, 1
;ps2_mouse.c,462 :: 		PS2_Clock_Direction_Mouse = 0;   // block clock
	BCF        TRISC1_bit+0, 1
;ps2_mouse.c,463 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,464 :: 		PS2_Data_Direction_Mouse  = 1;
	BSF        TRISC0_bit+0, 0
;ps2_mouse.c,465 :: 		PS2_Data_Mouse   = 1;           // release data line
	BSF        RC0_bit+0, 0
;ps2_mouse.c,466 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,467 :: 		}
L_end_PS2_Mouse_Write:
	RETURN
; end of _PS2_Mouse_Write

_PS2_Mouse_Write_Read:

;ps2_mouse.c,469 :: 		void PS2_Mouse_Write_Read(byte *Command, byte CountWrite, byte *Reply, byte CountRead)
;ps2_mouse.c,472 :: 		PS2_Mouse_Write(Command, CountWrite);
	MOVF       FARG_PS2_Mouse_Write_Read_Command+0, 0
	MOVWF      FARG_PS2_Mouse_Write_Values+0
	MOVF       FARG_PS2_Mouse_Write_Read_CountWrite+0, 0
	MOVWF      FARG_PS2_Mouse_Write_Count+0
	CALL       _PS2_Mouse_Write+0
;ps2_mouse.c,473 :: 		if (CountRead > 0)
	MOVF       FARG_PS2_Mouse_Write_Read_CountRead+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L_PS2_Mouse_Write_Read92
;ps2_mouse.c,475 :: 		I = 0;
	CLRF       PS2_Mouse_Write_Read_I_L0+0
;ps2_mouse.c,476 :: 		PS2_Clock_Mouse = 1;
	BSF        RC1_bit+0, 1
;ps2_mouse.c,477 :: 		PS2_Clock_Direction_Mouse = 1;  // enable the mouse to send
	BSF        TRISC1_bit+0, 1
;ps2_mouse.c,478 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,479 :: 		while (I < CountRead)
L_PS2_Mouse_Write_Read93:
	MOVF       FARG_PS2_Mouse_Write_Read_CountRead+0, 0
	SUBWF      PS2_Mouse_Write_Read_I_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_PS2_Mouse_Write_Read94
;ps2_mouse.c,481 :: 		Reply[I] = PS2_Mouse_Get_Byte();
	MOVF       PS2_Mouse_Write_Read_I_L0+0, 0
	ADDWF      FARG_PS2_Mouse_Write_Read_Reply+0, 0
	MOVWF      FLOC__PS2_Mouse_Write_Read+0
	CALL       _PS2_Mouse_Get_Byte+0
	MOVF       FLOC__PS2_Mouse_Write_Read+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;ps2_mouse.c,482 :: 		I++;
	INCF       PS2_Mouse_Write_Read_I_L0+0, 1
;ps2_mouse.c,483 :: 		}
	GOTO       L_PS2_Mouse_Write_Read93
L_PS2_Mouse_Write_Read94:
;ps2_mouse.c,484 :: 		PS2_Clock_Mouse = 0;
	BCF        RC1_bit+0, 1
;ps2_mouse.c,485 :: 		PS2_Clock_Direction_Mouse = 0;  // disable the mouse to send
	BCF        TRISC1_bit+0, 1
;ps2_mouse.c,486 :: 		Delay_us(2);
	NOP
	NOP
	NOP
	NOP
;ps2_mouse.c,487 :: 		}
L_PS2_Mouse_Write_Read92:
;ps2_mouse.c,488 :: 		}
L_end_PS2_Mouse_Write_Read:
	RETURN
; end of _PS2_Mouse_Write_Read

_main:

;so.c,17 :: 		void main()
;so.c,22 :: 		signed int X = 8;
	MOVLW      8
	MOVWF      main_X_L0+0
	MOVLW      0
	MOVWF      main_X_L0+1
	MOVLW      8
	MOVWF      main_Y_L0+0
	MOVLW      0
	MOVWF      main_Y_L0+1
;so.c,26 :: 		ANSEL  = 0;                                         // Configure AN pins as digital I/O
	CLRF       ANSEL+0
;so.c,27 :: 		ANSELH = 0;
	CLRF       ANSELH+0
;so.c,28 :: 		C1ON_bit = 0;                                       // Disable comparators
	BCF        C1ON_bit+0, 7
;so.c,29 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, 7
;so.c,31 :: 		Delay_ms(100);                                      // Wait for keyboard to finish
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L_main95:
	DECFSZ     R13+0, 1
	GOTO       L_main95
	DECFSZ     R12+0, 1
	GOTO       L_main95
	DECFSZ     R11+0, 1
	GOTO       L_main95
	NOP
;so.c,32 :: 		trisb=0;
	CLRF       TRISB+0
;so.c,33 :: 		portb=0;
	CLRF       PORTB+0
;so.c,36 :: 		if (!PS2_Mouse_Init())
	CALL       _PS2_Mouse_Init+0
	MOVF       R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_main96
;so.c,39 :: 		}
	GOTO       L_main97
L_main96:
;so.c,43 :: 		Cmd = 0xE9;  // status request command
	MOVLW      233
	MOVWF      main_Cmd_L0+0
;so.c,44 :: 		PS2_Mouse_Write_Read(&Cmd, 1, Reply, 3);
	MOVLW      main_Cmd_L0+0
	MOVWF      FARG_PS2_Mouse_Write_Read_Command+0
	MOVLW      1
	MOVWF      FARG_PS2_Mouse_Write_Read_CountWrite+0
	MOVLW      main_Reply_L0+0
	MOVWF      FARG_PS2_Mouse_Write_Read_Reply+0
	MOVLW      3
	MOVWF      FARG_PS2_Mouse_Write_Read_CountRead+0
	CALL       _PS2_Mouse_Write_Read+0
;so.c,45 :: 		rb0_bit = 1 ;
	BSF        RB0_bit+0, 0
;so.c,46 :: 		rb1_bit = 1 ;
	BSF        RB1_bit+0, 1
;so.c,47 :: 		rb2_bit = 1 ;
	BSF        RB2_bit+0, 2
;so.c,48 :: 		rb3_bit = 1 ;
	BSF        RB3_bit+0, 3
;so.c,49 :: 		delay_ms(500);
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L_main98:
	DECFSZ     R13+0, 1
	GOTO       L_main98
	DECFSZ     R12+0, 1
	GOTO       L_main98
	DECFSZ     R11+0, 1
	GOTO       L_main98
	NOP
	NOP
;so.c,50 :: 		portb=0;
	CLRF       PORTB+0
;so.c,51 :: 		while (true)
L_main99:
;so.c,54 :: 		if (PS2_Mouse_ReadData(&MouseData))
	MOVLW      main_MouseData_L0+0
	MOVWF      FARG_PS2_Mouse_ReadData_MouseData+0
	CALL       _PS2_Mouse_ReadData+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main101
;so.c,56 :: 		rb4_bit = MouseData.Keys.B0 ;
	BTFSC      main_MouseData_L0+0, 0
	GOTO       L__main148
	BCF        RB4_bit+0, 4
	GOTO       L__main149
L__main148:
	BSF        RB4_bit+0, 4
L__main149:
;so.c,58 :: 		rb5_bit = MouseData.Keys.B1 ;
	BTFSC      main_MouseData_L0+0, 1
	GOTO       L__main150
	BCF        RB5_bit+0, 5
	GOTO       L__main151
L__main150:
	BSF        RB5_bit+0, 5
L__main151:
;so.c,60 :: 		X += MouseData.DeltaX;
	MOVF       main_MouseData_L0+1, 0
	ADDWF      main_X_L0+0, 0
	MOVWF      R0+0
	MOVF       main_X_L0+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      main_MouseData_L0+2, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      main_X_L0+0
	MOVF       R0+1, 0
	MOVWF      main_X_L0+1
;so.c,61 :: 		X = X%100;
	MOVLW      100
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Div_16x16_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      main_X_L0+0
	MOVF       R0+1, 0
	MOVWF      main_X_L0+1
;so.c,62 :: 		if(X > 60){
	MOVLW      128
	MOVWF      R2+0
	MOVLW      128
	XORWF      R0+1, 0
	SUBWF      R2+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main152
	MOVF       R0+0, 0
	SUBLW      60
L__main152:
	BTFSC      STATUS+0, 0
	GOTO       L_main102
;so.c,63 :: 		rb2_bit=0;
	BCF        RB2_bit+0, 2
;so.c,64 :: 		rb3_bit = 1 ;
	BSF        RB3_bit+0, 3
;so.c,65 :: 		}
	GOTO       L_main103
L_main102:
;so.c,66 :: 		else if(X < -60){
	MOVLW      128
	XORWF      main_X_L0+1, 0
	MOVWF      R0+0
	MOVLW      127
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main153
	MOVLW      196
	SUBWF      main_X_L0+0, 0
L__main153:
	BTFSC      STATUS+0, 0
	GOTO       L_main104
;so.c,67 :: 		rb3_bit=0;
	BCF        RB3_bit+0, 3
;so.c,68 :: 		rb2_bit = 1 ;
	BSF        RB2_bit+0, 2
;so.c,69 :: 		}
L_main104:
L_main103:
;so.c,73 :: 		Y += MouseData.DeltaY;
	MOVF       main_MouseData_L0+3, 0
	ADDWF      main_Y_L0+0, 0
	MOVWF      R0+0
	MOVF       main_Y_L0+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      main_MouseData_L0+4, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      main_Y_L0+0
	MOVF       R0+1, 0
	MOVWF      main_Y_L0+1
;so.c,74 :: 		Y = Y % 100;
	MOVLW      100
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Div_16x16_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      main_Y_L0+0
	MOVF       R0+1, 0
	MOVWF      main_Y_L0+1
;so.c,75 :: 		if(Y > 60){
	MOVLW      128
	MOVWF      R2+0
	MOVLW      128
	XORWF      R0+1, 0
	SUBWF      R2+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main154
	MOVF       R0+0, 0
	SUBLW      60
L__main154:
	BTFSC      STATUS+0, 0
	GOTO       L_main105
;so.c,76 :: 		rb0_bit=0;
	BCF        RB0_bit+0, 0
;so.c,77 :: 		rb1_bit = 1 ;
	BSF        RB1_bit+0, 1
;so.c,78 :: 		}
	GOTO       L_main106
L_main105:
;so.c,79 :: 		else if(Y < -60){
	MOVLW      128
	XORWF      main_Y_L0+1, 0
	MOVWF      R0+0
	MOVLW      127
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main155
	MOVLW      196
	SUBWF      main_Y_L0+0, 0
L__main155:
	BTFSC      STATUS+0, 0
	GOTO       L_main107
;so.c,80 :: 		rb1_bit=0;
	BCF        RB1_bit+0, 1
;so.c,81 :: 		rb0_bit = 1 ;
	BSF        RB0_bit+0, 0
;so.c,82 :: 		}
L_main107:
L_main106:
;so.c,84 :: 		}
L_main101:
;so.c,85 :: 		Delay_ms(10);
	MOVLW      26
	MOVWF      R12+0
	MOVLW      248
	MOVWF      R13+0
L_main108:
	DECFSZ     R13+0, 1
	GOTO       L_main108
	DECFSZ     R12+0, 1
	GOTO       L_main108
	NOP
;so.c,86 :: 		rb0_bit=0;
	BCF        RB0_bit+0, 0
;so.c,87 :: 		rb1_bit=0;
	BCF        RB1_bit+0, 1
;so.c,88 :: 		rb2_bit=0;
	BCF        RB2_bit+0, 2
;so.c,89 :: 		rb3_bit=0;
	BCF        RB3_bit+0, 3
;so.c,90 :: 		}
	GOTO       L_main99
;so.c,91 :: 		}
L_main97:
;so.c,92 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
