
_main:

;so.c,8 :: 		void main() {
;so.c,10 :: 		ANSEL  = 0;                                         // Configure AN pins as digital I/O
	CLRF       ANSEL+0
;so.c,11 :: 		ANSELH = 0;
	CLRF       ANSELH+0
;so.c,12 :: 		C1ON_bit = 0;                                       // Disable comparators
	BCF        C1ON_bit+0, 7
;so.c,13 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, 7
;so.c,15 :: 		Ps2_Config();                                       // Init PS/2 Keyboard
	CALL       _Ps2_Config+0
;so.c,16 :: 		Delay_ms(100);                                      // Wait for keyboard to finish
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L_main0:
	DECFSZ     R13+0, 1
	GOTO       L_main0
	DECFSZ     R12+0, 1
	GOTO       L_main0
	DECFSZ     R11+0, 1
	GOTO       L_main0
	NOP
;so.c,17 :: 		trisb=0;
	CLRF       TRISB+0
;so.c,18 :: 		portb=0;
	CLRF       PORTB+0
;so.c,19 :: 		do {
L_main1:
;so.c,20 :: 		if (Ps2_Key_Read(&keydata, &special, &down)) {
	MOVLW      _keydata+0
	MOVWF      FARG_Ps2_Key_Read_value+0
	MOVLW      _special+0
	MOVWF      FARG_Ps2_Key_Read_special+0
	MOVLW      _down+0
	MOVWF      FARG_Ps2_Key_Read_pressed+0
	CALL       _Ps2_Key_Read+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main4
;so.c,21 :: 		if (down && (keydata == 16)) {                  // Backspace
	MOVF       _down+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main7
	MOVF       _keydata+0, 0
	XORLW      16
	BTFSS      STATUS+0, 2
	GOTO       L_main7
L__main64:
;so.c,22 :: 		rb2_bit=~rb2_bit;
	MOVLW      4
	XORWF      RB2_bit+0, 1
;so.c,23 :: 		}
	GOTO       L_main8
L_main7:
;so.c,24 :: 		else if (down && (keydata == 15)) {             // Enter
	MOVF       _down+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main11
	MOVF       _keydata+0, 0
	XORLW      15
	BTFSS      STATUS+0, 2
	GOTO       L_main11
L__main63:
;so.c,25 :: 		rb1_bit=~rb1_bit;                                                      // for new line transition
	MOVLW      2
	XORWF      RB1_bit+0, 1
;so.c,26 :: 		}
	GOTO       L_main12
L_main11:
;so.c,27 :: 		else if (down && (keydata == 1)) {             // F1
	MOVF       _down+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main15
	MOVF       _keydata+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main15
L__main62:
;so.c,28 :: 		rb0_bit=~rb0_bit;                                                      // for new line transition
	MOVLW      1
	XORWF      RB0_bit+0, 1
;so.c,29 :: 		}
L_main15:
L_main12:
L_main8:
;so.c,30 :: 		if(down && (keydata == 13))
	MOVF       _down+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main18
	MOVF       _keydata+0, 0
	XORLW      13
	BTFSS      STATUS+0, 2
	GOTO       L_main18
L__main61:
;so.c,31 :: 		portb=0;
	CLRF       PORTB+0
L_main18:
;so.c,32 :: 		if(down && (keydata == 32)) {
	MOVF       _down+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main21
	MOVF       _keydata+0, 0
	XORLW      32
	BTFSS      STATUS+0, 2
	GOTO       L_main21
L__main60:
;so.c,33 :: 		if(rb0_bit==0 && rb1_bit==0 && rb2_bit==0){
	BTFSC      RB0_bit+0, 0
	GOTO       L_main24
	BTFSC      RB1_bit+0, 1
	GOTO       L_main24
	BTFSC      RB2_bit+0, 2
	GOTO       L_main24
L__main59:
;so.c,34 :: 		portb=0;
	CLRF       PORTB+0
;so.c,35 :: 		rb0_bit=1;
	BSF        RB0_bit+0, 0
;so.c,36 :: 		}
	GOTO       L_main25
L_main24:
;so.c,37 :: 		else if(rb0_bit==1 && rb1_bit==0 && rb2_bit==0){
	BTFSS      RB0_bit+0, 0
	GOTO       L_main28
	BTFSC      RB1_bit+0, 1
	GOTO       L_main28
	BTFSC      RB2_bit+0, 2
	GOTO       L_main28
L__main58:
;so.c,38 :: 		portb=0;
	CLRF       PORTB+0
;so.c,39 :: 		rb1_bit=1;
	BSF        RB1_bit+0, 1
;so.c,40 :: 		}
	GOTO       L_main29
L_main28:
;so.c,41 :: 		else if(rb0_bit==0 && rb1_bit==1 && rb2_bit==0){
	BTFSC      RB0_bit+0, 0
	GOTO       L_main32
	BTFSS      RB1_bit+0, 1
	GOTO       L_main32
	BTFSC      RB2_bit+0, 2
	GOTO       L_main32
L__main57:
;so.c,42 :: 		portb=0;
	CLRF       PORTB+0
;so.c,43 :: 		rb2_bit=1;
	BSF        RB2_bit+0, 2
;so.c,44 :: 		}
	GOTO       L_main33
L_main32:
;so.c,45 :: 		else if(rb0_bit==0 && rb1_bit==0 && rb2_bit==1){
	BTFSC      RB0_bit+0, 0
	GOTO       L_main36
	BTFSC      RB1_bit+0, 1
	GOTO       L_main36
	BTFSS      RB2_bit+0, 2
	GOTO       L_main36
L__main56:
;so.c,46 :: 		portb=0;
	CLRF       PORTB+0
;so.c,47 :: 		rb0_bit=1;
	BSF        RB0_bit+0, 0
;so.c,48 :: 		}
L_main36:
L_main33:
L_main29:
L_main25:
;so.c,49 :: 		}
L_main21:
;so.c,50 :: 		if(down && (keydata == 33)) {
	MOVF       _down+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main39
	MOVF       _keydata+0, 0
	XORLW      33
	BTFSS      STATUS+0, 2
	GOTO       L_main39
L__main55:
;so.c,51 :: 		if(rb0_bit==0 && rb1_bit==0 && rb2_bit==1){
	BTFSC      RB0_bit+0, 0
	GOTO       L_main42
	BTFSC      RB1_bit+0, 1
	GOTO       L_main42
	BTFSS      RB2_bit+0, 2
	GOTO       L_main42
L__main54:
;so.c,52 :: 		portb=0;
	CLRF       PORTB+0
;so.c,53 :: 		rb1_bit=1;
	BSF        RB1_bit+0, 1
;so.c,54 :: 		}
	GOTO       L_main43
L_main42:
;so.c,55 :: 		else if(rb0_bit==0 && rb1_bit==1 && rb2_bit==0){
	BTFSC      RB0_bit+0, 0
	GOTO       L_main46
	BTFSS      RB1_bit+0, 1
	GOTO       L_main46
	BTFSC      RB2_bit+0, 2
	GOTO       L_main46
L__main53:
;so.c,56 :: 		portb=0;
	CLRF       PORTB+0
;so.c,57 :: 		rb0_bit=1;
	BSF        RB0_bit+0, 0
;so.c,58 :: 		}
	GOTO       L_main47
L_main46:
;so.c,59 :: 		else if(rb0_bit==1 && rb1_bit==0 && rb2_bit==0){
	BTFSS      RB0_bit+0, 0
	GOTO       L_main50
	BTFSC      RB1_bit+0, 1
	GOTO       L_main50
	BTFSC      RB2_bit+0, 2
	GOTO       L_main50
L__main52:
;so.c,60 :: 		portb=0;
	CLRF       PORTB+0
;so.c,61 :: 		rb2_bit=1;
	BSF        RB2_bit+0, 2
;so.c,62 :: 		}
L_main50:
L_main47:
L_main43:
;so.c,63 :: 		}
L_main39:
;so.c,64 :: 		}
L_main4:
;so.c,65 :: 		Delay_ms(1);                                      // debounce
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_main51:
	DECFSZ     R13+0, 1
	GOTO       L_main51
	DECFSZ     R12+0, 1
	GOTO       L_main51
	NOP
	NOP
;so.c,66 :: 		} while (1);
	GOTO       L_main1
;so.c,67 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
