#include "PS2_Mouse.c"


void main()
{
 TMouseData MouseData;
 byte Cmd;
 byte Reply[3];
 signed int X = 8;
 signed int Y = 8;
 unsigned int Z = 0;

  ANSEL  = 0;                                         // Configure AN pins as digital I/O
  ANSELH = 0;
  C1ON_bit = 0;                                       // Disable comparators
  C2ON_bit = 0;

  Delay_ms(100);                                      // Wait for keyboard to finish
  trisb=0;
  portb=0;


 if (!PS2_Mouse_Init())
 {
 
 }
 else
 {

  Cmd = 0xE9;  // status request command
  PS2_Mouse_Write_Read(&Cmd, 1, Reply, 3);
    rb0_bit = 1 ;
    rb1_bit = 1 ;
    rb2_bit = 1 ;
    rb3_bit = 1 ;
  delay_ms(500);
  portb=0;
  while (true)
  {
   // Read the mouse movements and display the buttons and XYZ values
   if (PS2_Mouse_ReadData(&MouseData))
   {
    rb4_bit = MouseData.Keys.B0 ;
    //rb1_bit = MouseData.Keys.B2 ;
    rb5_bit = MouseData.Keys.B1 ;
    
    X += MouseData.DeltaX;
    X = X%100;
    if(X > 60){
    rb2_bit=0;
    rb3_bit = 1 ;
    }
    else if(X < -60){
    rb3_bit=0;
    rb2_bit = 1 ;
    }
    //portb = X;
    //Y += MouseData.DeltaY;
    //Z += MouseData.DeltaZ;
    Y += MouseData.DeltaY;
    Y = Y % 100;
    if(Y > 60){
     rb0_bit=0;
     rb1_bit = 1 ;
    }
    else if(Y < -60){
     rb1_bit=0;
     rb0_bit = 1 ;
    }

   }
   Delay_ms(10);
   rb0_bit=0;
   rb1_bit=0;
   rb2_bit=0;
   rb3_bit=0;
  }
 }
}